package com.yfd.platform.modules.specialDocument.domain;

import com.baomidou.mybatisplus.annotation.*;

import java.sql.Timestamp;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.io.Serializable;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 专项项目表
 * </p>
 *
 * @author LiMengNan
 * @since 2025-01-20
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("sd_project")
public class Project implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 项目ID
     */
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    /**
     * 项目编号
     */
    private String projectCode;

    /**
     * 项目类型：自定义
     */
    private String projectType;

    /**
     * 项目名称
     */
    private String projectName;

    /**
     * 项目描述
     */
    private String description;

    /**
     * 可扩展的Json对象
     */
    private String projectProps;

    /**
     * 项目启动时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private Timestamp projectTime;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Timestamp createTime;

    /**
     * 创建人
     */
    private String creator;

    /**
     * 备用字段1
     */
    private String custom1;

    /**
     * 备用字段2
     */
    private String custom2;

    /**
     * 备用字段3
     */
    private String custom3;



    /**
     * 本地存储空间id
     */
    private Integer localStorageId;

    /**
     * 上传用到KEY：TODO 增加用于前端展示
     */
    @TableField(exist = false)
    private String key;

    /**
     * 上传用到type：TODO 增加用于前端展示
     */
    @TableField(exist = false)
    private String type;

}
